"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _accodomdation = require("./accodomdation");

var _esf = require("./esf");

var _ffs = require("./ffs");

var _genericLine = require("./generic-line");

var _lift = require("./lift");

var _otherProducts = require("./other-products");

var _transfer = require("./transfer");

var _utils = require("./utils");

const defaultIntl = {
  formatMessage: key => key.id,
  locale: "fr"
};

const toRendableCart = (intl, cart, stationName) => {
  const {
    ESF,
    GENERIC_LINE,
    FFS,
    HOT,
    LIFT,
    SKI_RENTAL,
    STAND,
    TRANSFER,
    STAY_TAX,
    ESF_CUSTOM // PACKAGE
    // TODO : apparemment aucun ajout dans le cart actuel. Doit on le prendre en compte ?

  } = cart;
  const usedIntl = intl || defaultIntl;
  return [...HOT.map(hot => (0, _accodomdation.toRendableAccomodation)(usedIntl, hot, STAY_TAX.flatMap(st => st.inscriptions))), ...ESF.map(esf => (0, _esf.toRendableEsf)(usedIntl, esf)), ...ESF_CUSTOM.map(esfCustom => (0, _esf.toRendableEsfCustom)(usedIntl, esfCustom)), ...LIFT.map(lift => (0, _lift.toRendableLift)(usedIntl, lift)), ...SKI_RENTAL.map(skiRental => (0, _otherProducts.toRendableSkiRental)(usedIntl, skiRental)), ...STAND.map(stand => (0, _otherProducts.toRendableStand)(usedIntl, stand)), ...TRANSFER.map(transfer => (0, _transfer.toRendableTransfer)(usedIntl, transfer)), ...FFS.map(ffs => (0, _ffs.toRendableFFS)(usedIntl, ffs, stationName)), ...GENERIC_LINE.map(genericLine => (0, _genericLine.toRendableGenericLine)(usedIntl, genericLine))].map(_utils.computeMerchant);
};

var _default = toRendableCart;
exports.default = _default;