"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var React = _interopRequireWildcard(require("react"));

var _Layout = require("../Layout");

var _Context = _interopRequireDefault(require("../Context"));

var _types = require("./types");

var _Action = _interopRequireDefault(require("./Action"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ChevronRight = function ChevronRight(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    d: "M8.293 5.293a1 1 0 0 1 1.414 0l6 6a1 1 0 0 1 0 1.414l-6 6a1 1 0 0 1-1.414-1.414L13.586 12 8.293 6.707a1 1 0 0 1 0-1.414z"
  }));
};

ChevronRight.defaultProps = {
  viewBox: "0 0 24 24",
  xmlns: "http://www.w3.org/2000/svg"
};

var ChevronDown = function ChevronDown(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    fillRule: "evenodd",
    clipRule: "evenodd",
    d: "M5.293 8.293a1 1 0 0 1 1.414 0L12 13.586l5.293-5.293a1 1 0 1 1 1.414 1.414l-6 6a1 1 0 0 1-1.414 0l-6-6a1 1 0 0 1 0-1.414z"
  }));
};

ChevronDown.defaultProps = {
  viewBox: "0 0 24 24",
  xmlns: "http://www.w3.org/2000/svg"
};

var Cross = function Cross(props) {
  return /*#__PURE__*/React.createElement("svg", props, /*#__PURE__*/React.createElement("path", {
    fillRule: "evenodd",
    clipRule: "evenodd",
    d: "M18.707 5.293a1 1 0 0 1 0 1.414l-12 12a1 1 0 0 1-1.414-1.414l12-12a1 1 0 0 1 1.414 0z"
  }), /*#__PURE__*/React.createElement("path", {
    fillRule: "evenodd",
    clipRule: "evenodd",
    d: "M5.293 5.293a1 1 0 0 1 1.414 0l12 12a1 1 0 0 1-1.414 1.414l-12-12a1 1 0 0 1 0-1.414z"
  }));
};

Cross.defaultProps = {
  viewBox: "0 0 24 24",
  xmlns: "http://www.w3.org/2000/svg"
};
const cssFonts = {
  fontFamily: "Open Sans, Helvetica"
};
const cssFontsBold = { ...cssFonts,
  fontWeight: 700
};
const cssInscription = {
  paddingLeft: 40
};

const cssInscriptionTitle = solo => ({
  paddingTop: solo ? 20 : "initial",
  paddingBottom: solo ? 15 : "initial"
});

const cssInscriptionTitleText = {
  fontSize: 20,
  color: "#4d4d4d",
  ...cssFonts
};
const cssInscriptionLabel = {
  fontWeight: "bold",
  ...cssInscriptionTitleText
};
const cssInscriptionPax = {
  marginLeft: 10,
  ...cssInscriptionTitleText
};
const cssInscriptionPrice = {
  fontSize: 20,
  color: "#4d4d4d",
  ...cssFontsBold
};
const cssinscriptionDetails = {
  padding: "5px 0 5px 20px"
};
const cssInscriptionDivider = {
  width: "100%",
  border: "none",
  height: "1px",
  margin: "20px 0 0 0",
  backgroundColor: "#4d4d4d",
  opacity: "0.25"
};
const cssDetails = {
  cursor: "pointer"
};
const cssDetailsButtonOut = {
  display: "inherit"
};
const cssDetailsButtonIn = {
  display: "inline-block",
  borderBottom: "1px solid #CC0900",
  color: "#CC0900",
  fontSize: "12px",
  ...cssFonts
};
const cssDetailsChevron = {
  fill: "#CC0900",
  width: 15,
  marginLeft: 5
};
const cssRemoveCross = {
  fill: "#4d4d4d",
  width: 15,
  cursor: "pointer"
};

const Inscription = ({
  label,
  pax,
  price,
  mode = _types.modeEnum.simple,
  actions,
  divider,
  subtitle,
  details,
  removeAction
}) => {
  const context = React.useContext(_Context.default);
  const [opened, setOpened] = React.useState(mode !== _types.modeEnum.simple);
  const displayActions = actions;
  const displayRemove = removeAction && !context.mail;
  const displayDetailsButton = details && !context.mail;
  const forceDetails = details && context.mail;
  return /*#__PURE__*/React.createElement(_Layout.Box, {
    css: cssInscription
  }, /*#__PURE__*/React.createElement(_Layout.Row, null, /*#__PURE__*/React.createElement(_Layout.Cell, {
    css: cssInscriptionTitle(!!subtitle),
    md: 10,
    content: "text"
  }, /*#__PURE__*/React.createElement("span", {
    style: cssInscriptionLabel
  }, label), /*#__PURE__*/React.createElement("span", {
    style: cssInscriptionPax
  }, pax)), /*#__PURE__*/React.createElement(_Layout.Cell, {
    css: cssInscriptionPrice,
    md: 1,
    align: "center"
  }, price, "\u20AC"), displayRemove && /*#__PURE__*/React.createElement(_Layout.Cell, {
    md: 1,
    onClick: removeAction,
    align: "center"
  }, /*#__PURE__*/React.createElement(Cross, {
    style: cssRemoveCross
  }))), subtitle && /*#__PURE__*/React.createElement(_Layout.Row, null, /*#__PURE__*/React.createElement(_Layout.Cell, {
    md: forceDetails ? 12 : 10
  }, subtitle), displayDetailsButton && /*#__PURE__*/React.createElement(_Layout.Cell, {
    md: 1,
    css: cssDetails,
    onClick: () => {
      setOpened(!opened);
    },
    align: "center"
  }, /*#__PURE__*/React.createElement("span", {
    style: cssDetailsButtonOut
  }, /*#__PURE__*/React.createElement("span", {
    style: cssDetailsButtonIn
  }, "Details"), opened ? /*#__PURE__*/React.createElement(ChevronDown, {
    style: cssDetailsChevron
  }) : /*#__PURE__*/React.createElement(ChevronRight, {
    style: cssDetailsChevron
  })))), (opened || forceDetails) && details && /*#__PURE__*/React.createElement(_Layout.Row, null, /*#__PURE__*/React.createElement(_Layout.Cell, null, /*#__PURE__*/React.createElement(_Layout.Box, {
    css: cssinscriptionDetails
  }, details))), (displayActions || divider) && /*#__PURE__*/React.createElement(_Layout.Row, null, /*#__PURE__*/React.createElement(_Layout.Cell, {
    md: 12
  }, /*#__PURE__*/React.createElement("hr", {
    style: cssInscriptionDivider
  }))), displayActions && actions.map(({
    hint,
    label,
    onClick
  }, index) => /*#__PURE__*/React.createElement(_Action.default, {
    key: index,
    hint: hint,
    label: label,
    onClick: onClick,
    marginTop: 20
  })));
};

var _default = Inscription;
exports.default = _default;