"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.newAttachment = void 0;

var _mailgunJs = _interopRequireDefault(require("mailgun-js"));

var _config = _interopRequireDefault(require("config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mailgun = (0, _mailgunJs.default)({
  apiKey: _config.default.get("mailgun.api_key"),
  domain: _config.default.get("mailgun.domain"),
  host: _config.default.has("mailgun.host") ? _config.default.get("mailgun.host") : undefined
}); // TODO faire autant de factoryMailgun que de channel puis utiliser la bonne en dessous ;)
// TODO get info mailgun from constant by channel

const sendMail = (data, mailgunConfig, logger, fn) => {
  const mg = mailgunConfig ? (0, _mailgunJs.default)({
    apiKey: mailgunConfig.apiKey,
    domain: mailgunConfig.domain,
    host: mailgunConfig.host
  }) : mailgun;
  return new Promise((resolve, reject) => {
    mg.messages().send(data, (error, body) => {
      if (error !== undefined) {
        if (logger) {
          logger.error(JSON.stringify(error));
          logger.error(error.message);
        }

        return reject(new Error(`An error occured while sending email: ${error.message},__JSON__:${JSON.stringify(data)}`));
      } else if (fn) fn(body);

      return resolve();
    });
  });
};

const newAttachment = (data, filename, contentType = "application/pdf") => new mailgun.Attachment({
  data,
  filename,
  contentType,
  knownLength: data.length
});

exports.newAttachment = newAttachment;
var _default = sendMail;
exports.default = _default;