"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.unionBy = exports.union = void 0;

const union = (xs1, xs2) => Array.from(new Set(xs1.concat(xs2)));

exports.union = union;

const unionBy = key => (xs1, xs2) => {
  const dynamic = typeof key === "function";
  return xs1.concat(xs2).filter(function (x) {
    const value = dynamic ? key(x) : x[key];
    return this.has(value) ? false : this.add(value);
  }, new Set());
};

exports.unionBy = unionBy;